namespace StudySystemClient {
	public class Card : Gtk.Frame {
		public Card() {
			hexpand = true;
			add_css_class("card");
		}
	}

	public class CardArea : Gtk.Box {
		private Gtk.FlowBox flow_box;

		public CardArea() {
			hexpand = vexpand = true;
			margin_top = margin_bottom = margin_start = margin_end = 0;

			flow_box = new Gtk.FlowBox();
			flow_box.homogeneous = true;
			flow_box.min_children_per_line = 1;
			flow_box.max_children_per_line = 1;
			flow_box.selection_mode = Gtk.SelectionMode.NONE;
			flow_box.valign = Gtk.Align.START;

			var scrolled_window = new Gtk.ScrolledWindow();
			scrolled_window.hscrollbar_policy = Gtk.PolicyType.NEVER;
			scrolled_window.hexpand = scrolled_window.vexpand = true;
			scrolled_window.add_css_class("card-container");
			scrolled_window.set_child(flow_box);

			append(scrolled_window);
		}

		public void clear() {
			flow_box.remove_all();
		}

		public void add(Card card) {
			flow_box.append(card);
		}
	}
}
